Name: alternatives
Version: 0.1.0
Release: alt2

Summary: alternatives support
License: GPL
Group: System/Base

Packager: Stanislav Ievlev <inger@altlinux.ru>

Source0: %name-%version.tar.bz2
Patch1: %name-0.1.0-alt-allow-same.patch

PreReq: lib%name = %version-%release

%def_without test

# Automatically added by buildreq on Wed Jun 25 2003
BuildRequires: XFree86-libs alt-entities docbook-dtds docbook-style-xsl doxygen freetype2 gcc-c++ graphviz libgd2 libing-devel libjpeg libstdc++-devel libxml2-devel libxslt xml-common xpm xsltproc

Provides: %_sysconfdir/%name/packages.d

%description
Alternatives subsystem. This package contains common utilites for it.

%package -n lib%name
Summary: Common library for alternatives
Group: System/Libraries

%description -n lib%name
This package contains common library for all alternatives utilities

%package -n lib%name-devel
Summary: Development part of lib%name library
Group: Development/C++
Requires: lib%name = %version-%release
Requires: libing-devel

%description -n lib%name-devel
This package contains header files and development libraries for lib%name

%package -n lib%name-devel-static
Summary: Development part of lib%name library
Group: Development/C++
Requires: lib%name-devel = %version-%release

%description -n lib%name-devel-static
This package contains static libraries for lib%name

%prep
%setup -q
%patch1 -p1

%build
%add_optflags -DCONFIGFILE=\\\"%_sysconfdir/%name/%name.xml\\\" -DLOCKFILE=\\\"%_lockdir/%name/lock\\\"
%make_build
%if_with test
%make check
%endif

%install
%make_install PREFIX=/usr DESTDIR=$RPM_BUILD_ROOT install

install -d $RPM_BUILD_ROOT%_sysconfdir/rpm/macros.d
cat >$RPM_BUILD_ROOT%_sysconfdir/rpm/macros.d/%name<<EOF
%%_altdir %%([ ! -f %_libdir/lib%name.so ])%_sysconfdir/%name/packages.d

%%register_alternatives %_sbindir/%name-helper --install 
%%reg_alts %%register_alternatives
%%post_register_alternatives %%register_alternatives
%%post_reg_alts %%post_register_alternatives

%%unregister_alternatives [ "\$1" = 0 ] || exit 0; [ -x %_sbindir/%name-helper ] && %_sbindir/%name-helper --remove 
%%unreg_alts %%unregister_alternatives
%%preun_unregister_alternatives %%unregister_alternatives
%%preun_unreg_alts %%preun_unregister_alternatives

%%unregister_alternatives_always [ -x %_sbindir/%name-helper ] && %_sbindir/%name-helper --remove 
%%unreg_alts_always %%unregister_alternatives_always

%%update_alternatives() [ -x %_sbindir/%name-update ] && %_sbindir/%name-update %%* ||: %%nil
%%update_alts %%update_alternatives
%%post_update_alternatives %%update_alternatives
%%post_update_alts %%update_alternatives

%%remove_alternatives [ "\$1" = 0 ] || exit 0; [ -x %_sbindir/%name-update ] && %_sbindir/%name-update --ignore 
%%remove_alts %%remove_alternatives
%%preun_remove_alternatives %%remove_alternatives
%%preun_remove_alts %%preun_remove_alternatives
EOF

%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig

#since 0.0.5 we have no manual directory: save user settings
%triggerun -- alternatives < 0.0.5-alt1
if [ -d /etc/alternatives/manual/ ]
then
    for i in `find /etc/alternatives/manual/ -type f`
    do
	mv -f $i %_sysconfdir/%name/auto/
    done
fi

%files
%doc doc/html NEWS ChangeLog
%_sbindir/*
%_sysconfdir/%name
%_man8dir/*

%files -n lib%name
%_libdir/*.so.*
%attr(700,root,root) %dir %_lockdir/%name

%files -n lib%name-devel
%doc doc/api/html/*
%_includedir/%name
%_libdir/*.so
%_sysconfdir/rpm/macros.d/*

%files -n lib%name-devel-static
%_libdir/*.a

%changelog
* Wed Jun 16 2004 Stanislav Ievlev <inger@altlinux.org> 0.1.0-alt2
- allow same candidates (specially for java)

* Thu Jun 26 2003 Stanislav Ievlev <inger@altlinux.ru> 0.1.0-alt1
- 0.1.0
- more documentation
- minor bugfixes, code improvements

* Mon Jun 09 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.7-alt2
- added provides for /etc/alternatives/ packages.d
- don't make test by default

* Mon May 05 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.7-alt1
- next release

* Tue Apr 08 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.6-alt1
- minor features, bugfuxes

* Fri Mar 28 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.5-alt3
- trigger fix

* Thu Mar 27 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.5-alt2
- fix memory leak
- added more tests

* Wed Mar 26 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.5-alt1
- removed some dups in code, no manual dir now

* Tue Mar 25 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.4-alt6
- added RPM macros variants with post/preun suffixes
- check nested slaves support
- '-D' option for alternatives-list
- negative tests ready: make check available

* Mon Mar 24 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.4-alt5
- added testcase for various bad configs

* Fri Mar 21 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.4-alt4
- ignore now ignore slaves too

* Fri Mar 21 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.4-alt3
- fix update logic from alternatived programs to non-alternatived
  (added %%unregister_alternatives_always macro for it)
- made %%update_alternatives,
       %%remove_altenatives 
       %%unregister_altenatives
  macros more friendly for nonexistent update-alternatives file
- added requires to latest libing (was changes in format config)
- more testcase

* Thu Mar 20 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.4-alt2
- fix alternatives_link creation during update

* Wed Mar 19 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.4-alt1
- now alternatives-list works under user

* Mon Mar 17 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.3-alt4.M2
- fix update from non-alternatived programs

* Sat Mar 15 2003 Stanislav Ievlev <inger@altlinux.org> 0.0.3-alt3.M2
- little improvements again

* Sat Mar 15 2003 Stanislav Ievlev <inger@altlinux.org> 0.0.3-alt2.M2
- fix latest improvements

* Fri Mar 14 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.3-alt1.M2
- some fixes and improvements

* Wed Mar 12 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.2-alt6.M2
- rebuild with lates libing
- added short variants to rpm macros
- added hack for macros to auto buildreq
- repeat update until we have no changes (helps in some ugly cases)

* Tue Mar 11 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.2-alt5.M2
- fix removing old slave links

* Fri Mar 07 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.2-alt4.M2
- alternatives --install fixes
- work only with existent files
- change macros names
- more testcase
- fix dump file usage
- little code improvements(friend classes,use default processing)

* Thu Mar 06 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.2-alt3.M2
- M2: daedalus release
- testcase and samples included

* Thu Mar 06 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.2-alt2.M2
- alternatives-setup, M2, RC1

* Wed Mar 05 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.2-alt1.M2
- alternatives-update, pre-M2

* Fri Feb 28 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.1-alt2.M1
- fix ldconfig usage according packaging policy
- minor internal fixes

* Fri Feb 21 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.1-alt1.M1
- second daedalus release:
   move some code into shared library (preparation for M2 - second utility)
   added lockfile support
   added migration info into README

* Wed Feb 05 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.0-alt2.M1
- daedalus release

* Tue Feb 04 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.0-alt1.M1
- fix map usage

* Mon Feb 03 2003 Stanislav Ievlev <inger@altlinux.ru> 0.0.0-alt0.M1
- Initial release, with some demo stuff
